module Formic
  class Form < Base
    default_template 'formic/default/form'

    attr_reader :model, :action

    def _initialize options={}, &block
      super options, &block
      self.options[:method] ||= 'POST'
    end

    def put options={}, &block
      self.options[:method ] = 'POST'
      self.options[:_method] = 'PUT'
      self.content = block if block_given?
      return self
    end

    def create model, options={}, &block
      options[:title] ||= "New #{model.class.to_s.underscore}".gsub('_', ' ').titleize
      @action = :create

      return _initialize_with_model(
        model,
        options[:action] || self.page.url_for(model),
        "create_#{model.class.to_s.downcase}_form",
        options,
        &block
      )
    end

    def edit model, options={}, &block
      self.put

      @action = :edit
      options[:title] ||= "Edit #{model.class.to_s.underscore}".gsub('_', ' ').titleize
      return _initialize_with_model(
        model,
        options[:action] || self.page.url_for(model),
        "edit_#{model.class.to_s.downcase}_form",
        options,
        &block
      )
    end

    def method_missing action, model, options={}, &block
      @action = action
      options[:title] ||= "#{action} #{model.class.to_s.underscore}".gsub('_', ' ').titleize
      return _initialize_with_model(
        model,
        options[:action] || "#{self.page.url_for(model)}/#{action}",
        "#{action}_#{model.class.to_s.downcase}_form",
        options,
        &block
      )
    end

    def _initialize_with_model model, action, classname, options={}, &block
      options[:title] ||= "#{action} #{model.class.to_s.underscore}".gsub('_', ' ').titleize
      @model = model
      self.merge_options(options)
      self.options[:method] ||= 'POST'
      self.options[:action] ||= action
      self.options[:class].push classname
      self.content = block if block_given?
      return self
    end
  end
end
