require 'formic'

module Formic
  module Helper
    def self.formic_helper *names
      names.each do |name|
        define_method(name) { |*args, &block|
          name = :menu if name == :menu_bar
          klass = get_class(name)
          object = klass.new(self, *args, &block)
          return object
        }
      end
    end

    formic_helper(
      :selection,
      :input,
      :password,
      :checkbox,
      :list,
      :list_item,
      :list_items,
      :tab,
      :form,
      :tab_panel,
      :button,
      :textarea
    )

    def get_class symbol
      classname = ''
      elements = symbol.to_s.split('_')
      elements.each do |element|
        classname += element.capitalize
      end
      return "Formic::#{classname}".constantize
    end
  end
end
