require 'forwardable'

module Formic
  class ListItems < Base
    default_template 'formic/default/list_items'

    attr_reader :items
    extend Forwardable
    def_delegators :@items, :size, :push, :pop, :<<, :[], :shift, :unshift, :each, :length, :first, :last

    def _initialize list=[], options={}, &block
      super  &block
      @items = []

      list.each do |item|
        @items.push ListItem.new(self.page, item, options)
      end

      return self
    end

    def add_class class_name
      @items.each do |item|
        item.add_class class_name
      end
    end

  end
end
